#ifndef CONSTEXPR_H
#define CONSTEXPR_H 

class Constexpr_example {
public:
    constexpr static int N = 8;
};

template<int N> constexpr bool Is_prime() noexcept {
	if constexpr (N < 2) return false; // C++17
	if constexpr (N == 2) return true; // C++17
	else { // This branch is discarded at compilation time when 'N == 2'
		bool is_prime = true;
		for (int i = 2; i < N; i++)
			if (N % i == 0) {
				is_prime = false;
				break;
			}
		return is_prime;
	}
}

static_assert(::Is_prime<2>()); // No compilation error
// static_assert(::Is_prime<Constexpr_example::N>()); // Compilation error since 'Constexpr_example::N == 8'

#endif /* CONSTEXPR_H */

